import java.util.Random;

public class Engine 
{
private double [][] populatie;
private int populatieGrootte;
private int diepte;
private Zet spelerEen;
private Zet spelerTwee;
//private int aantalPotjes=0;
//private int zetTeller=0;

public Engine(double [][] gen, int pop, int dieptet)
{
	diepte=dieptet;
	populatieGrootte=pop;
	populatie = gen;
}

public double [][] geefGemiddelde ()
{
	int teller;
	int tellert;
	double [][] resultaat = new double [2] [26];
	double tijdelijk;
	for (teller=0; teller<26; teller++)
	{
		tijdelijk=0.0;
		for (tellert=0; tellert<populatieGrootte; tellert++)
			tijdelijk += populatie [tellert][teller];
		tijdelijk /= populatieGrootte;
		resultaat [0][teller] = tijdelijk;
	}// Voor het gemiddelde per evaluatiewaarde
	for (teller=0; teller<26; teller++)
	{
		tijdelijk=0.0;
		for (tellert=0; tellert<populatieGrootte; tellert++)
			tijdelijk += Math.abs(resultaat [0][teller]-populatie [tellert][teller]);
		tijdelijk /= populatieGrootte;
		resultaat [1][teller] = tijdelijk;
	}// Voor de gemiddelde afwijking tot het gemiddelde
	return resultaat;
}

public double [] [] geefPopulatie ()
{
	return populatie;
}

public double [][] startToernooi (int aantalRondes)
{
	doeToernooi (aantalRondes);
	return populatie;
}

public void maakStartPopulatie ()
{
	populatie = new double[populatieGrootte][26];
	Random generator = new Random();
	int t;
	for(t=0; t < populatieGrootte; t++)
	{
		populatie[t][0] = generator.nextInt(100) - 100; // C
		populatie[t][1] = generator.nextInt(25); 		// E
		populatie[t][2] = generator.nextInt(25);		// F
		populatie[t][3] = 100;							// H
		populatie[t][4] = generator.nextInt(10) - 10;	// I
		populatie[t][5] = generator.nextInt(10) - 10;	// J
		populatie[t][6] = generator.nextInt(10);			// K
		populatie[t][7] = generator.nextInt(10);			// M
		populatie[t][8] = generator.nextInt(100) - 100;	// X
		populatie[t][9] = generator.nextInt(10); 		// Y
		populatie[t][10] = generator.nextInt(20) + 5;	// W
		populatie[t][11] = 10.0;//s1 C
		populatie[t][12] = 2.5;//s2 E
		populatie[t][13] = 2.5;//s3 F
		populatie[t][14] = 10.0;//s4 H
		populatie[t][15] = 1.0;//s5 I
		populatie[t][16] = 1.0;//s6 J
		populatie[t][17] = 1.0;//s7 K
		populatie[t][18] = 1.0;//s8 M
		populatie[t][19] = 10.0;//s9 X
		populatie[t][20] = 1.0;//s10 Y
		populatie[t][21] = 2.0;//s11 W
		populatie[t][22] = generator.nextInt(50);	//C` 
		populatie[t][23] = generator.nextInt(50);	//X`
		populatie[t][24] = 5.0;	//sC`
		populatie[t][25] = 5.0;	//sX`
	}
}

private void doeToernooi (int aantalGeneraties)
{
	int t;
	for(t=0; t < aantalGeneraties; t++)
	{
		speelRonde();
	}
}


private void speelRonde()
{
	int[][] uitslag = new int[populatieGrootte][2];
	int t1;
	for(t1=0; t1 < populatieGrootte; t1++)
	{
		uitslag[t1][0] = 0;
		uitslag[t1][1] = 0;
	}
	scramblePopulatie();
	int speler1;
	int speler2 = 0;
	for(speler1=0; speler1 < populatieGrootte; speler1++)
	{
		
		while(uitslag[speler1][0] < 5)
		{
			if(speler2 < (populatieGrootte-1))
				speler2++;
			else
				speler2 = speler1 + 1;
			if(speler1 != speler2 && uitslag[speler2][0] < 5)
			{
				uitslag[speler1][0]++;
				uitslag[speler2][0]++;
				spelerEen = new Zet(populatie[speler1], 1);
				spelerTwee = new Zet(populatie[speler2], -1);
				int winnaar = speelPotje();
				//aantalPotjes++;
				//System.out.println(aantalPotjes + " potjes gespeeld, deze met " + zetTeller + " zetten...");
				if(winnaar == 1)
				{
					uitslag[speler1][1] += 1;
					uitslag[speler2][1] += -2;
				}
				if(winnaar == -1)
				{
					uitslag[speler2][1] += 1;
					uitslag[speler1][1] += -2;
				}
			}
 		}
	}
	populatie = evolueerGeneratie(populatie, uitslag);
}

public int speelPotje ()
{
	//zetTeller = 0;
	Veld bord = new Veld ();
	int team = 1;
	while (!bord.checkEinde())
	{
		if (bord.telGeldigeZetten(team) == 0)
			team*=-1;
		if (team == 1)
			bord = spelerEen.doeZet(bord, diepte); // diepte is de diepte van de gametree
		if (team == -1)
			bord = spelerTwee.doeZet(bord, diepte); // diepte is de diepte van de gametree
		//zetTeller++;
		team*=-1;
	}
	//bord.laatVeldZienSystem();
	//System.out.println("Potje gespeeld ...");
	if (bord.telStenen(team) < bord.telStenen(team*-1))
		return (team*-1);
	if (bord.telStenen(team) > bord.telStenen(team*-1))
		return (team);
	else
		return (0);
}

public double [][] evolueerGeneratie(double [][] generatie, int [][] uitslag)
{
	double [][] tgeneratie = new double [populatieGrootte][26];
	int t,t1;
	for (t1=0;t1<populatieGrootte/2;t1++)
	{
		double maxwin = -11.0;
		int maxwinplek = 0;
		for (t=0;t<populatieGrootte;t++)
		{
			if (uitslag[t][1] > maxwin)
			{
				maxwinplek = t;
				maxwin = uitslag[t][1];
			}
		}
		tgeneratie[t1] = generatie[maxwinplek];
		uitslag[maxwinplek][1] = -12;
	}
	
	for (t=0;t<populatieGrootte/2;t++)
	{
		double [] algor = new double [26];
		for(t1=0; t1<26; t1++)
			algor[t1] = tgeneratie[t][t1];
		tgeneratie[(populatieGrootte/2)+t] = evolueer(algor);
	}	
	return tgeneratie;
}
public double[] evolueer(double [] vector)
{
	int t;
	Random randomgen = new Random();
	double eersteStuk = randomgen.nextGaussian()/(4.89898); //=sqrt(2*12);
	double tweedeStuk;
	for (t=11;t<24;t++)
	{	
		tweedeStuk = randomgen.nextGaussian()/(2.63215);//=sqrt(2*sqrt 12)
		if (t == 22 || t == 23)
		{
			vector[t+2] = Math.max(0.1, vector[t+2] * ( Math. pow(Math.E, eersteStuk + tweedeStuk)));
			vector[t] = vector[t]+vector[t+2]*randomgen.nextGaussian();
		}
		else
		{
		vector[t] = Math.max(0.1, vector[t] * ( Math. pow(Math.E, eersteStuk + tweedeStuk)));
		if (t-11 != 3)
			vector[t-11] = vector[t-11]+vector[t]*randomgen.nextGaussian();
		}
	}
	/*eersteStuk = randomgen.nextGaussian()/(4.89898); //=sqrt(2*12)
	tweedeStuk = randomgen.nextGaussian()/(2.63215);//=sqrt(2*sqrt 12)
	vector[t] = Math.max(0.1, vector[t] * ( Math. pow(Math.E, eersteStuk + tweedeStuk)));
	vector[22] = vector[22]*/
	return vector;
}

private void scramblePopulatie ()
{
        double [][] resultaat=new double [populatieGrootte][26];
        boolean [] alGeweest = new boolean [populatieGrootte];
        int teller;
        Random randomizer = new Random();
        int a;
        int b;
        for (teller=0; teller<populatieGrootte; teller++)
        	alGeweest [teller] = false;
        for (a=0; a<populatieGrootte; a++)
        {
                b=randomizer.nextInt(populatieGrootte);
                while (alGeweest[b])
                        b=randomizer.nextInt(populatieGrootte);
                for (teller=0; teller<26; teller++)
                        resultaat [a][teller] = populatie [b][teller];
                alGeweest[b]=true;
        }
        for (a=0; a<populatieGrootte; a++)
        	for (b=0; b<26; b++)
        		populatie [a] [b] = resultaat [a][b];
}

}

