import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

public class ReversiApplication extends Frame implements WindowListener, ActionListener, Runnable
{
	public int populatieGrootte;
	private int generatieTeller;
	public int alphaBetaDiepte;
	private String fileNaam;
	private Button evolueerNieuw;
	private Button evolueerOpgeslagen;
	private Button stop;
	private Button nieuwSpel;
	private Thread evolueer;
	public Engine motor;
	private GrafischeUserInterface GUI;
	private String gemiddelden = "\n\nGemiddelden en hun gemiddelde afwijking tot het gemiddelde:\n";
	ReversiApplication ()
	{
		this.addWindowListener(this);
		this.setSize(400,600);
		this.setLayout( new FlowLayout() );
		
		stop = new Button("Stop");
		this.add(stop);
		stop.addActionListener(this);
		
		evolueerNieuw = new Button("Evolueer Nieuwe Generatie");
		this.add(evolueerNieuw);
		evolueerNieuw.addActionListener(this);
		evolueerOpgeslagen = new Button("Evolueer bewaarde Generatie");
		this.add(evolueerOpgeslagen);
		evolueerOpgeslagen.addActionListener(this);
		fileNaam = "Data.rev";
		
		GUI = new GrafischeUserInterface(this);
		this.add(GUI);
		GUI.repaint();
		
		nieuwSpel = new Button("Nieuw Spel");
		this.add(nieuwSpel);
		nieuwSpel.addActionListener(this);
		
		populatieGrootte = 2;
		generatieTeller=0;
		
		alphaBetaDiepte = 3;
		motor = new Engine (leesDataIn(), populatieGrootte, alphaBetaDiepte);
		//double [] [] gemiddelde = motor.geefGemiddelde();
		//int teller; 
		//for (teller =0; teller<26; teller++)
		//	System.out.print(gemiddelde [0][teller] + " " + gemiddelde [1][teller] + " - ");
		evolueer = new Thread(this);
		evolueer.start();
		evolueer.suspend();

	}
	public void paint (Graphics g)
	{
	}
	public static void main(String[] p)
	{ 
		ReversiApplication reversi = new ReversiApplication();
		reversi.setVisible(true);
	}
	public void windowClosing (WindowEvent e)
	{ 
		System.exit(0);
	}
	public void windowClosed (WindowEvent e) {}
	public void windowOpened (WindowEvent e) {}
	public void windowIconified (WindowEvent e) {}
	public void windowDeiconified(WindowEvent e) {}
	public void windowActivated (WindowEvent e) {}
	public void windowDeactivated(WindowEvent e) {}
	public void run()
	{
		schrijfDataWeg (motor.geefPopulatie());
		while (generatieTeller < 250)
			{
				generatieTeller++;
				schrijfDataWeg (motor.startToernooi(1));
				System.out.println(generatieTeller+" Generaties gedaan en opgeslagen in " + fileNaam + " ...");
				//System.out.println(" Opgeslagen...");
			}
	}
	
	public void doeWinst (int winst)
	{
		String winstString = "";
		switch (winst)
		{
		case (1): winstString = "Gefeliciteerd!\n\nU heeft Gewonnen!\n"; break;
		case (-1): winstString = "Jammer!\n\nU heeft (/bent) Verloren!\n"; break;	
		default: winstString = "Joh!\n\nU heeft gelijk gespeeld!\n"; break;
		}
		System.out.print(winstString);
	}
	
	public void actionPerformed(ActionEvent e)
    {
		if (e.getSource() == stop)
		{
			evolueer.suspend();
			//schrijfDataWeg(motor.geefPopulatie());
		}
        if (e.getSource() == evolueerNieuw)
        {	
        	gemiddelden ="\n\nGemiddelden en hun gemiddelde afwijking tot het gemiddelde:\n";
        	motor.maakStartPopulatie();
        	generatieTeller = 0;
        	evolueer = new Thread(this);
        	evolueer.start();
        }
        if (e.getSource() == evolueerOpgeslagen)
        {
        	gemiddelden ="\n\nGemiddelden en hun gemiddelde afwijking tot het gemiddelde (niet compleet):\n";
        	motor = new Engine (leesDataIn (), populatieGrootte, alphaBetaDiepte);
        	evolueer.resume();
        }
        if (e.getSource() == nieuwSpel)
        {
        	GUI.nieuwSpel();
        }
      }
	
    public void schrijfDataWeg (double [][] data)
    {   double [] [] gemiddelde;    
    	gemiddelde = motor.geefGemiddelde();
    	int teller;
    	if (generatieTeller%10==0)
    	{
    	gemiddelden+= generatieTeller + ": ";
	 	for (teller = 0; teller<26; teller++)
	 		gemiddelden += (gemiddelde [0][teller] + " " + gemiddelde [1][teller] + " - ");
	 	gemiddelden+='\n';
    	}
    	FileOutputStream out;
        PrintStream p;
        String s;
        try
        {
        	out = new FileOutputStream(fileNaam);
        	p = new PrintStream( out );
        	p.println(populatieGrootte + " " + generatieTeller);
        	for (teller=0; teller < populatieGrootte; teller++)
        	{
        		s="";
        		for (int tellert=0; tellert < 26; tellert++)
        			s+=data [teller][tellert] + " ";
        		p.println(s);
        	}
        	p.print(gemiddelden);
        	p.close();
        }
        catch (Exception e)
        {
        	System.err.println ("HELP! Er is iets mis met jouw computer, of ik stink! "+e);
        }
    }
    
    public double [][] leesDataIn ()
    {
    	int teller;
    	int tellert;
    	boolean gemiddeld=false;
    	String s;
    	String t;
    	try
		{
    		FileInputStream fstream = new FileInputStream(fileNaam);
            DataInputStream in = new DataInputStream(fstream);
            s=in.readLine();
            Scanner sc = new Scanner (s);
            populatieGrootte = sc.nextInt();
            generatieTeller = sc.nextInt();
            in.close ();
		}
        catch (Exception e)
		{
        	System.err.println("HELP! " + fileNaam + " bestaat niet, of jouw computer crasht! (Invoer: Int's) " + e);
		}
        double [][] data = new double [populatieGrootte][26];
        try
        {
        	FileInputStream fstream = new FileInputStream(fileNaam);
            DataInputStream in = new DataInputStream(fstream);
            Scanner sc;
            s=in.readLine();
            teller=0;
            while (in.available()!=0)
            {
            	s=in.readLine();
            	if (s.length()==0)
            		gemiddeld=true;
            	if (!gemiddeld)
            	{
            	sc = new Scanner (s);
            	double tijdelijk;
            	for (tellert=0; tellert < 26 && sc.hasNext() ; tellert++)
            	{
            		t=sc.next();
            		tijdelijk = new Double (t);
            		data [teller][tellert]= tijdelijk;
            	}
            	teller++;
            	}
            }
            in.close();  
		}
        catch (Exception e)
		{
        	System.err.println("HELP! " + fileNaam + " bestaat niet, of jouw computer crasht! (Invoer: Doubles) " + e);
    	}
       	return data;
   }

}


