
public class Zet 
{
	private double[] evaluatieWaarden;
	private int speler;
	private double [][] veldWaarden;
	Zet (double[] eW, int spelert)
	{
		evaluatieWaarden = eW;
		speler = spelert;
		double [][] tveldWaarden = {	{eW[3],eW[0],eW[1],eW[2],eW[2],eW[1],eW[0],eW[3]},
									{eW[0],eW[8],eW[4],eW[5],eW[5],eW[4],eW[8],eW[0]},
									{eW[1],eW[4],eW[9],eW[6],eW[6],eW[9],eW[4],eW[1]},
									{eW[2],eW[5],eW[6],eW[7],eW[7],eW[6],eW[5],eW[1]},
									{eW[2],eW[5],eW[6],eW[7],eW[7],eW[6],eW[5],eW[2]},
									{eW[1],eW[4],eW[9],eW[6],eW[6],eW[9],eW[4],eW[1]},
									{eW[0],eW[8],eW[4],eW[5],eW[5],eW[4],eW[8],eW[0]},
									{eW[3],eW[0],eW[1],eW[2],eW[2],eW[1],eW[0],eW[3]}};
		veldWaarden = tveldWaarden;
	}
	
	public Veld doeZet (Veld spelbord, int diepte)
	{
		double[] alpha = new double[3];
		alpha[0] = Double.NEGATIVE_INFINITY;
		alpha[1] = 9999;
		alpha[2] = 8888;
		double[] beta = new double[3];
		beta[0] = Double.POSITIVE_INFINITY;
		beta[1] = 7777;
		beta[2] = 6666;
		double[] zet = alphaBeta(speler, spelbord, diepte, alpha, beta);
		spelbord.doeZet((int)zet[1], (int)zet[2], speler);
		return spelbord;
	}
	
	public double[] kloontje(double[] alpha)
	{
		double[] result = new double[3];
		for(int t=0; t < 3; t++)
		{
			result[t] = alpha[t];
		}
		return result;
	}
	
	private double[] alphaBeta (int spelert, Veld spelbord, int diepte, double[] alpha, double[] beta)
	{
		boolean gezet = false;
		int x, y;
		double[] evalWaarde = new double[3];
		evalWaarde[1] = 4444;
		double evalWaardeTwee;
		//http://en.wikipedia.org/wiki/Alpha-beta_pruning
		
		for(x=0; x<8; x++)
		{
			for(y=0; y<8; y++)
			{
				if(spelbord.controleerZet(x, y, spelert) )
				{
					Veld kloon = spelbord.kloon();
					if(diepte > 0) 
					{
						kloon.doeZet(x,y, spelert);
						double[] kloonA = kloontje(alpha);
						double[] kloonB = kloontje(beta);
						kloonB[0] = Double.POSITIVE_INFINITY;
						if (kloon.telGeldigeZetten(-1*spelert) > 0)
						{
							evalWaarde = alphaBeta((-1*spelert), kloon, (diepte-1), kloonA, kloonB);
						}
						else
						{
							if (kloon.checkEinde())
							{
								if (kloon.telStenen(spelert) < kloon.telStenen(spelert*-1))
									evalWaarde[0] = -1 * spelert * Double.POSITIVE_INFINITY;
								if (kloon.telStenen(spelert) > kloon.telStenen(spelert*-1))
									evalWaarde[0] = spelert * Double.POSITIVE_INFINITY;
								else
									evalWaarde[0] = 0;
								evalWaarde[1] = x;
								evalWaarde[2] = y;
								return evalWaarde;
							}
							else
							{
								evalWaarde = alphaBeta((spelert), kloon, (diepte-2), kloonA, kloonB);	
							}
						}
						
						/*
						if node is a minimizing node
					        for each child of node
					            beta = min (beta, evaluate (child, alpha, beta))
					            if beta <= alpha
					                return beta
					        return beta
					    if node is a maximizing node
					        for each child of node
					            alpha = max (alpha, evaluate (child, alpha, beta))
					            if beta <= alpha
					                return alpha
					        return alpha
					    */
					        
						if(spelert == -1)
						{
							if(evalWaarde[0] <= beta[0])
							{
								beta[0] = evalWaarde[0];
								beta[1] = x;
								beta[2] = y;
							}
							if(beta[0] <= alpha[0])
								return beta;
						}
						else
						{
							if(evalWaarde[0] >= alpha[0])
							{
								alpha[0] = evalWaarde[0];
								alpha[1] = x;
								alpha[2] = y;
							}
							if(beta[0] <= alpha[0])
								return alpha;
						}
					}
					else
					{
						evalWaardeTwee = bordEval(kloon, spelert);
						double[] result = new double[3];
						result[0] = evalWaardeTwee;
						result[1] = x;
						result[2] = y;
						return result;
					}
				}
				else
				{
					if(!gezet && beta[1] == 7777)
						;//System.out.println ("ongeldige zet" + beta[0] + beta[1]);
				}
			}
		}	        
		if(spelert == -1)
			return beta;
		else
			return alpha;
	}
	
	///Wesley
	
	private double bordEval (Veld bord, int spelert) 
	{
			int i,j;
			double stab = 0.0;
			for (i=0; i<8; i++)
				for (j=0; j<8; j++)
				{
					if (	(i==1 && j==0 && bord.vak[0][0]==spelert) ||
							(i==0 && j==1 && bord.vak[0][0]==spelert) ||
							(i==6 && j==0 && bord.vak[7][0]==spelert) ||
							(i==7 && j==1 && bord.vak[7][0]==spelert) ||
							(i==0 && j==6 && bord.vak[0][7]==spelert) ||
							(i==1 && j==7 && bord.vak[0][7]==spelert) ||
							(i==7 && j==6 && bord.vak[7][7]==spelert) ||
							(i==6 && j==7 && bord.vak[7][7]==spelert)
						)
							stab += bord.vak [i][j] * evaluatieWaarden [22];
					else 
						{
						if (
						
							(i==1 && j==1 && bord.vak[0][0]==spelert) ||
							(i==6 && j==6 && bord.vak[7][7]==spelert) ||
							(i==1 && j==6 && bord.vak[0][7]==spelert) ||
							(i==6 && j==1 && bord.vak[7][0]==spelert)
							)
							stab += bord.vak [i][j] * evaluatieWaarden [23];	
						else
							stab += bord.vak [i][j] * veldWaarden[i][j];
						}
				}
			//System.out.println("Evaluatie: " + (stab + (bord.telGeldigeZetten(speler) * evaluatieWaarden[10])));
			return (stab + spelert*(bord.telGeldigeZetten(spelert) * evaluatieWaarden[10]));
	}

}
